import { Iterable } from 'immutable'
import plain from '../plain/index'

const { deepEqual } = plain

const deepEqualValues = (a, b) => {
  if (Iterable.isIterable(a)) {
    if (Iterable.isIterable(b)) {
      return a.count() === b.count() &&
        a.every((value, key) => deepEqualValues(value, b.get(key)))
    }
    return false
  }
  return deepEqual(a, b) // neither are immutable iterables
}

export default deepEqualValues
